"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.defineRequirement = void 0;
var react_1 = __importDefault(require("react"));
/**
 * Helper function for defining requirements
 * @description Creates requirement from particular component and props that will be passed to it
 * @template T type of props for this `Requirement` component
 * @param Requirement component type that will be used as HOC for wrapping `ApplicationRoot`
 * @param props actual props that have to be passed to `Requirement`
 * @returns requirement that could be easily used by `ResolvableComponent` or `withRequirements` HOC
 */
function defineRequirement(Requirement, props) {
    return function (app) {
        return react_1.default.createElement(Requirement, __assign({}, props), app);
    };
}
exports.defineRequirement = defineRequirement;
//# sourceMappingURL=defineRequirement.js.map